#!/usr/bin/env python

#
# Standard library
#

def dedup(l):
	"Deduplicate a list, using dict/keys"
	d={}
	for k in l:
		d[k]=1
	
	return d.keys()

def lookupDef(hash,v,d=0):
	"Dict lookup with default value (0)"
	try:
		return hash[v]
	except KeyError:
		return d

def smooth(l, factor=0.8):
	"Smooth list L using a belief-factor FACTOR"
	ret=[]
	n=l[0]
	for i in l:
		n+=(i-n)*factor
		ret.append(n)
		
	return ret

def pigIndex(seq, f):
    "Return the index of the first item in seq where f(item) is True."
    return next((i for i in xrange(len(seq)) if f(seq[i])), None)

